<!-- Component allowing to warn the user of his choice during a deletion attempt -->
<template>
  <b-modal
    ref="modal-delete"
    v-model="show_modal"
    size="sm"
    title="Confirm"
    @ok="onOk"
    @cancel="onCancel"
  >
    <form action="">
      <b-container>
        Êtes-vous sûr ?
      </b-container>
    </form>
  </b-modal>
</template>

<script>
export default {
  name: 'Dialog',
  props: {
    // Data to be deleted
    dataToDelete: { type: Object, required: false, default: null },
    // To display the modal
    show: { type: Boolean, default: false }
  },
  computed: {
    // We listen to the props show and use it as a model to avoid a mistake
    show_modal: {
      /**
       * Returns the value of the props show
       * @return {Boolean}
       */
      get () {
        return this.show
      },
      /**
       * Sends an event to the component if there are changes in show_modal
       */
      set () {
        this.hideModal()
      }
    }
  },
  methods: {
    /**
     * Function to send a cancel event
     */
    onCancel () {
      this.$emit('cancelevent', false)
    },
    /**
     * Function to send a success event
     */
    onOk () {
      this.$emit('okevent', this.dataToDelete)
    },
    /**
     * Function to close the modal
     */
    hideModal () {
      this.$refs['modal-delete'].hide()
      this.$emit('closemodalevent', false)
    }
  }
}
</script>

<style scoped>

</style>
